;=============================================================================
;
;DWORD dizx  (DWORD* bufer,DWORD* out,DWORD* table)
;
;=============================================================================
;out:   eax=command length or [-1]

bufer_param	equ		[esp+4*8]+4
out_param	equ		[esp+4*8+4]+4
table_param	equ		[esp+4*8+8]+4

disasm          proc
		pusha

		mov esi,bufer_param			;esi=input_bufer
		mov edi,out_param

		mov ebp,edi
		xor eax,eax
		smov ecx,<SIZE output>
		rep stosb

		xor edx,edx				;edx=size=0
@@__dizcycle:

;==============================================================================
;There are we check unusual commands(command in ax)
;==============================================================================

		push esi
		lodsw					;get first byte+second
		pop esi

		xchg ebx,edx				;ebx=old edx
		smov edx,3				;edx=3

		cmp al,9ah				;call far?
		je @@__mov_7

		cmp al,0c8h				;enter?
		je @@__mov_4

		cmp ax,020cdh				;int 20h?
		je @@__mov_6				

		cmp al,0c2h				;retn n
		je @@__mov_3

		cmp al,0cAh				;retf n
		je @@__mov_3

		cmp al,0eah				;jmp yyyy:xxxxxxxx
		je @@__mov_7

		xchg edx,ebx				;edx=old edx

                jmp @@__usual_work
@@__mov_7:
		inc edx
@@__mov_6:
		inc edx
@@__mov_5:
		inc edx
@@__mov_4:
		inc edx
@@__mov_3:
		jmp @@__no_op

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@__op_prefix:
		or dh,OUT_FLAG_O_PREFIX			;set operand prefix
		jmp @@__end_prefix

@@__mem_prefix:
		or dh,OUT_FLAG_A_PREFIX	      		;set mem prefix
		jmp @@__end_prefix

@@__just_prefix:
		or dh,OUT_FLAG_JUST_PREFIX

@@__end_prefix:	
		inc byte ptr[ebp.prefix_size]

		inc edx                                 ;size++
		inc esi					;next byte read
		jmp @@__dizcycle

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

@@__usual_work:
		;esi=command offset
		;eax=command
		mov ebx,table_param			;ebx=offset of tables

		cmp al,0fh				;extended command?
		jne @@__usual_no_extd

		;//extended

		add ebx,256*2				;ex new table
		mov [ebp.descryptor.mask1],al		;//0x0f
		shr eax,8

@@__usual_no_extd:
		xor ah,ah
		mov bx,word ptr[ebx+eax*2]

		inc bx
		jz @@__disasmErr			;bx=-1?
		dec ebx

		;al=command opcode
		;ebx=all descryptor

;#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#~#
;				Create Mask

		mov ecx,ebx

		mov ch,cl
		shr ch,5				 
		inc ch					 ;cl=mask length

		mov cl,8
		sub cl,ch

		mov ch,0ffh				 ;ch=11111111b
		shl ch,cl				 ;make mask
		and ch,al				 ;ch=command mask

		test bl,EX_0F
		jnz  @@__msk_second

		mov [ebp.descryptor.mask1],ch		 ;first mask
		jmp @@__msk_pop
@@__msk_second:

		mov [ebp.descryptor.mask2],ch
@@__msk_pop:

		mov word ptr[ebp.descryptor.mask_flag],bx;save flags

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
		test BH,O_PREFIX         ;01
		jnz @@__op_prefix

		test BH,A_PREFIX         ;10
		jnz @@__mem_prefix

		test BH,_PREFIX	         ;11
		jnz @@__just_prefix
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;No prefixes here

		push esi
		lodsd					;get opcodes+modr/m+sib
		pop esi					;esi=commnd offset

		inc edx					;one byte in all times

		test bl,EX_0F
		jz  @@__cmd_one_byte
		
		inc edx					;if present 2nd byte
		inc esi                                 ;==\ add esi,1
@@__cmd_one_byte:					;  |====add esi,2
		inc esi                                 ;==/add esi,1
		
		test bl,MODR_M
		jz @@__no_modrm				;if zero then no modr_m!

;==============================================================================
;			-------- MODRM is present ---------		      ; 
;==============================================================================

		inc esi					;esi=sib (?)
@@__sib_test:
		inc edx					;size++

		mov edi,eax				;edi=opcodes+modrm+sib
		;EDI=MORDR/M

		test bl,EX_0F
		jz @@__one_SHR
				
		shr edi,8				;\
@@__one_SHR:                                               ; |--shr edi,16
                                                        ; |
		shr edi,8				;/ edi=modr/m
@@__get_modrm:



;==============================================================================
;		--------- Exception OP TEST ---------
;==============================================================================

		test bl,EXEPT_NEED
		jz @@__no_expt_c_op

		push eax

                mov ecx,ebx

		mov eax,edi					;al=modr/m

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		or [ebp.ex_flags],EXT_MODRM			;set modr/m flag
		mov [ebp.modrm],al                              ;save mdr/m

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		and al,00111000b				;get cur c/op
		shr al,3					;al =cur c/op

		;ch=mask field
		shl ch,8-3
		mov cl,3
	
@@__test_exept_bit:

		shl ch,1
		jc @@__exept_bit_present

@@__test_exept_next:
		dec cl
		jnz @@__test_exept_bit

;==================================no exept====================================
		jmp @@__test_exit

@@__exept_bit_present:
	
		cmp cl,1
		jz @@__1_c_op

		cmp cl,2
		jz @@__2_c_op
	
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@__3_c_op:
		mov ch,EXEPT_OP_3
		jmp @@__see_c_op
@@__2_c_op:
		mov ch,EXEPT_OP_2
		jmp @@__see_c_op
@@__1_c_op:
		mov ch,EXEPT_OP_1
@@__see_c_op:
		cmp al,ch
		jne @@__test_exept_next
@@__error_op:
		pop eax
		jmp @@__disasmErr

@@__test_exit:
		pop eax

;##############################################################################

@@__no_expt_c_op:
		push ebx				;save descryptor
		push eax

		mov ebx,edi				;bx=di=modr/m+sib
		mov eax,ebx				;ax=bx=modr/m+sib

		and bl,00111000b			;get 2nd reg
		shr bl,3

		test byte ptr[esp+8+1],C_OP		;test c/op flag[esp+0+1]
		jz @@__reg2get				;if it not present then zf=1
		                           
		or [ebp.descryptor.modr_m_flag],bl;save c/op
		jmp @@__reg1_get

@@__reg2get:
		mov [ebp.reg2_base],bl			;save reg2
		or  dh,OUT_FLAG_REG2BASE		;set flag

@@__reg1_get:
;##############################################################################
; r/m - reg1
; reg/cop -reg 2
		mov ebx,edi				;ebx=edi=modr/m

		mov bh,bl				;bl=bh=modr/m
		and bh,11000000b			;BH= mod
		and bl,00000111b			;BL= r/m

		cmp bh,11000000b
		je @@__reg1_reg				;register or memory ?

		or [ebp.ex_flags],EXT_REG_MEM		;set memory flag

		cmp bl,00000100b			;SIB?
		je @@__sib_extd	
		;no sib (mem or reg)
@@__reg1_reg:
		mov [ebp.reg1],bl			;save reg2
		or  DH,OUT_FLAG_REG1			;set flag

		jmp @@_sib_exit
		
;##############################################################################
;			-------- SIB present ---------			      ; 
@@__sib_extd:

		;BH=mod
		;BL=r/m=100b
		;AH=sib

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		or [ebp.ex_flags],EXT_SIB			;set sib flag
		mov [ebp.sib],ah                              ;save sib

;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


		mov al,ah				;al= ss|index|base
		and ah,00000111b			;AH=base
		
		and al,00111000b			
		shr al,3                                ;AL=index

		cmp al,00000101b			;we have [ebp] or 
		jne @@__sib_base			;just offset_32/8/16?	

		or bh,bh				;mod=00?
		je @@__sib_check_index

@@__sib_base:		

		test dh,OUT_FLAG_REG2BASE		;reg2 present?
		jz @@__no_swap				;no swap

		mov bl,[ebp.reg2_base]			;swap regs(use free bl)
		mov [ebp.reg1],bl
		or  dh,OUT_FLAG_REG1			;set flag
@@__no_swap:

		mov [ebp.reg2_base],ah			;save base
		or  dh,OUT_FLAG_REG2BASE 		;OR OUT_FLAG_BASE_REG
							;set reg2_base field=> it's a base_field on flags
@@__sib_check_index:

		cmp ax,0000010000000100b		;[esp] or index?
		je @@__sib_no_index

		mov [ebp.index_reg],al			;save index
		or  DH,OUT_FLAG_INDEX			;set index bit
@@__sib_no_index:

       		inc edx					;size++
		inc esi					;esi=offset in command

@@_sib_exit:
		pop eax
		pop ebx
@@__no_sib:

;##############################################################################
;------------------------- OFFSET TEST ----------------------------------------

		;edi=modr/m ,esi=offset
		push eax				;save command
		xor ecx,ecx				;offset length=0
		mov eax,edi

		and al,11000111b			;get mod & r/m
		cmp al,00000101b			;just offset32
		je @@__offset_dword_word		;if not just offset32

		and di,11000000b			;get mod

		cmp di,01000000b			;BYTE offset<<<
		je @@__offset_byte

		cmp di,10000000b			;DWORD/WORD offset<<<
		jne @@__no_offset_present

;==============================================================================
;			-------- OFFSET present ---------		      ; 
;==============================================================================

@@__offset_dword_word:
		test DH,OUT_FLAG_A_PREFIX
		jz @@__offset_dword

		;WORD OFFSET

		inc ecx
@@__offset_byte:
		inc ecx
		jmp @@__offset_present

@@__offset_dword:
		mov cl,4
@@__offset_present:

		add edx,ecx
		;ecx=length
		lea edi,[ebp.mem_offset]
		rep movsb

		or DH,OUT_FLAG_OFFSET			;set offset bit

@@__no_offset_present:
		pop eax					;load command
@@__no_modrm:


;=============================== w bitget ===================================
		mov ecx,ebx
		shr cl,5				;cl=len mask

		test bl,EX_0F
		jz @@__one_byte

		shr eax,8				;eax=last opcod+modr/m+sib 
@@__one_byte:
		cmp cl,7-1				;w presents
		je @@__wnext_7

		cmp cl,6-1				;d(s) & w present
		je @@__wnext_6

		cmp cl,4-1				;w & reg present
		jne @@__op
@@__wnext_4:
		push eax
		and al,00000111b			;get reg
		mov [ebp.reg1],al			;save reg1
		pop eax

		or DH,OUT_FLAG_REG1			;set r1 bit

		and al,00001000b			;if (w_flag=1){ZF=0}
		shl al,3				;set mask style
		jmp @@@wset_ex


@@__wnext_6:
		;get D bit state:
		test [ebp.descryptor.mask_flag],DW_EXIST  
		jz @@__no_D                             ;get mask flags

		push eax
		and al,00000010b			;get d bit
		shl al,6				;mask style
		or [ebp.ex_flags],al			;set d state
		pop eax
@@__no_D:

@@__wnext_7:
		and al,00000001b			;get w bit
		shl al,6				;create ex_flag
@@@wset_ex:
		or [ebp.ex_flags],al			;set w bit
@@__op:
;------------------------------ OPERAND TEST -------------------------------
		xor eax,eax				;size op/mem=0

		and bh,00110000b			;get operand field
		jz @@__no_op				;op=0?

		or DH,OUT_FLAG_OPERAND 			;set operand present

		cmp bh,OP_BYTE_OPERAND			;byte op?
		je @@__byte

		cmp bh,OP_DWORD_OPERAND			;dword/word?
		je @@__dword__word

;=============================================================================
		;W=0 => byte operand
		;W=1 => dword/word operand

		test [ebp.ex_flags],EXT_W_STATE
		jz @@__byte

@@__dword__word:

		test DH,OUT_FLAG_O_PREFIX	 	;operand prefix
		jz @@__dword

		;WORD OPERAND
		inc eax
@@__byte:		
		inc eax
		jmp @@__size_end
@@__dword:
		mov al,4				;increase on 4
@@__size_end:

		add edx,eax
		mov byte ptr[ebp.size_operand],al			;set size
		xchg ecx,eax                     		;ecx=len operand

		;ESI=operand offset
		lea edi,[ebp.operand]				;edi=point op/mem
		rep movsb

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@__no_op:
		mov [ebp.com_size],dl			;save size (in output)
		mov [ebp.o_flags],DH
		xor dh,dh

@@__error_exit:
		mov [esp._eax],edx			;save size (in eax)

		popa
		ret
@@__disasmErr:
		xor edx,edx
		dec edx		
		jmp @@__error_exit

disasm          endp